Index: azure_iot_hub/trunk/asp3_dcre/tecsgen/tecslib/core/componentobj.rb
===================================================================
--- azure_iot_hub/trunk/asp3_dcre/tecsgen/tecslib/core/componentobj.rb	(revision 388)
+++ azure_iot_hub/trunk/asp3_dcre/tecsgen/tecslib/core/componentobj.rb	(revision 389)
@@ -2357,17 +2251,14 @@
   end
 
-  #=== Cell# PORT (celltype ã®å®ç¾©) ãå¾ã
+  #=== Cell# PORT (celltype の定義) を得る
   def get_real_port( port_name )
 
-    # composite ãï¼
+    # composite か？
     if @celltype.instance_of?( CompositeCelltype ) then
 
-      # ã»ã«ã¿ã¤ãå
-ã§ port_name ã® CompositeCelltypeJoin ãæ¢ãï¼ã³ã¼ãçææ®µéã§ã¯å¿
-ãè¦ã¤ããï¼
+      # セルタイプ内で port_name の CompositeCelltypeJoin を探す（コード生成段階では必ず見つかる）
       cj = @celltype.find_export( port_name )
 
-      # composite ã®å
-é¨ã®ã»ã«ã«å¯¾ãåå¸°çã« get_real_port ãé©ç¨
+      # composite の内部のセルに対し再帰的に get_real_port を適用
       port = @cell_list[ "#{cj.get_cell_name}" ].get_real_port( cj.get_cell_elem_name )
       return port
@@ -2378,20 +2269,17 @@
   end
 
-  #=== Cell# cell ãå¾ã
-  #    composite ã§ãªããã°èªåèªèº«ãè¿ã
+  #=== Cell# cell を得る
+  #    composite でなければ自分自身を返す
   def get_real_cell( port_name )
 
-    # composite ãï¼
+    # composite か？
     if @celltype.instance_of?( CompositeCelltype ) then
 
-      # ã»ã«ã¿ã¤ãå
-ã§ port_name ã® CompositeCelltypeJoin ãæ¢ãï¼ã³ã¼ãçææ®µéã§ã¯å¿
-ãè¦ã¤ããï¼
+      # セルタイプ内で port_name の CompositeCelltypeJoin を探す（コード生成段階では必ず見つかる）
       # print "get_real_cell: cell=#{@name} port=#{port_name}\n"
       # pp @cell_list
       cj = @celltype.find_export( port_name )
 
-      # composite ã®å
-é¨ã®ã»ã«ã«å¯¾ãåå¸°çã« get_real_port ãé©ç¨
+      # composite の内部のセルに対し再帰的に get_real_port を適用
       cell = @cell_list[ "#{cj.get_cell_name}" ].get_real_cell( cj.get_cell_elem_name )
       return cell
@@ -2412,7 +2300,6 @@
   end
 
-  #=== Cell# åãå£ã®port ã®åç
-§ã«ã¦ã³ããã¢ãããã
-  #port_name:: Symbol  : ãã¼ãå
+  #=== Cell# 受け口のport の参照カウントをアップする
+  #port_name:: Symbol  : ポート名
   def port_referenced port
     if @referenced_port_list[ port ] then
@@ -2422,17 +2309,14 @@
     end
 
-    # composite ãï¼
+    # composite か？
     if @celltype.instance_of?( CompositeCelltype ) then
 
-      # ã»ã«ã¿ã¤ãå
-ã§ port_name ã® CompositeCelltypeJoin ãæ¢ãï¼ã³ã¼ãçææ®µéã§ã¯å¿
-ãè¦ã¤ããï¼
+      # セルタイプ内で port_name の CompositeCelltypeJoin を探す（コード生成段階では必ず見つかる）
       cj = @celltype.find_export( port.get_name )
 
       dbgPrint " port_referenced: #{@celltype.get_name} #{@name} cj=#{cj&&(cj.get_name)||"nil"}\n"
 
-      if cj then  # æ¢ã«ã¨ã©ã¼
-        # composite ã®å
-é¨ã®ã»ã«ã«å¯¾ãåå¸°çã« get_real_port ãé©ç¨
+      if cj then  # 既にエラー
+        # composite の内部のセルに対し再帰的に get_real_port を適用
         cell = @cell_list[ "#{cj.get_cell_name}" ]
         if cell && cell.get_celltype then
@@ -2457,7 +2341,6 @@
   end
 
-  #Cell#å±æ§ã®åæå¤ãå¾ã
-  #attr_name::Symbol  å¿
-ãåæåããã¦ããªãã¨ Ruby ä¾å¤ã¨ãªã
+  #Cell#属性の初期値を得る
+  #attr_name::Symbol  必ず初期化されていないと Ruby 例外となる
   def get_attr_initializer attr_name
     val = @join_list.get_item( attr_name )
@@ -2499,6 +2382,5 @@
   end
 
-  #=== Cell# åãå£é
-åã®æ·»æ°ã®æå¤§å¤ãè¨­å®
+  #=== Cell# 受け口配列の添数の最大値を設定
   def set_entry_port_max_subscript( port, num )
     dbgPrint( "set_entry_port_max_subscript: #{@name}.#{port.get_name}: #{num}\n" )
@@ -2511,15 +2393,11 @@
   end
 
-  #=== Cell# composite ã®å
-å´ã»ã«ã®åãå£é
-åã®æ·»æ°ã®æå¤§å¤ãè¨­å®
+  #=== Cell# composite の内側セルの受け口配列の添数の最大値を設定
   def set_entry_inner_port_max_subscript( port, num )
     if @cell_list == nil then
-      return    # ãã­ãã¿ã¤ãå®£è¨ããããã¦ããªãã¦ãå
-å´ã»ã«ãå±éããã¦ããªããor composite å±éå
-    end
-
-    # composite ã®å
-å´ã®ã»ã«ã«ä¼æ­
+      return    # プロトタイプ宣言しかされていなくて、内側セルが展開されていない　or composite 展開前
+    end
+
+    # composite の内側のセルに伝播
     if @celltype.instance_of? CompositeCelltype then
       dbgPrint "set_entry_inner_port_max_subscript #{@name} #{@port} #{num} cell_list.len=#{@cell_list.length}\n"
@@ -2538,8 +2416,7 @@
   end
 
-  #=== Cell# åãå£é
-åã®æ·»æ°ã®æå¤§å¤ãè¿ã
-  # é·ãã¯ +1 ãã
-  # 1ã¤ããªãå ´åã¯ -1 ãè¿ã
+  #=== Cell# 受け口配列の添数の最大値を返す
+  # 長さは +1 する
+  # 1つもない場合は -1 を返す
   def get_entry_port_max_subscript( port )
     subscript = @entry_array_max_subscript[port]
@@ -2550,14 +2427,13 @@
   end
 
-  #=== Cell# ãªã¬ã¼ã¢ã­ã±ã¼ã¿ã®çµåãçæ
+  #=== Cell# リレーアロケータの結合を生成
   # STAGE: S
-  # å¼ã³å£å´ã®çµåãå
-ã«åãå£å´ã®çµåãçæ
+  # 呼び口側の結合を元に受け口側の結合を生成
   def create_relay_allocator_join
 
-    # celltype ããªããã°ãã§ãã¯ããªãï¼æ¢ã«ã¨ã©ã¼ï¼
+    # celltype がなければチェックしない（既にエラー）
     return if @celltype == nil
 
-    # relay allocator ãçæ
+    # relay allocator を生成
     @celltype.get_port_list.each { |p|
       ail = p.get_allocator_instance
@@ -2565,5 +2441,5 @@
         dbgPrint "create_relay_allocator_join: #{@name}, #{p.get_name}\n"
         if p.get_array_size then
-          # mikan relay allocator ã array ã«å¯¾å¿ã§ãã¦ãããã®ã§ã¯ï¼
+          # mikan relay allocator が array に対応できてもよいのでは？
           cdl_error( "S1040 array not supported for relay allocator"  )
           next
@@ -2573,12 +2449,11 @@
           if ai2[0] == :RELAY_ALLOC then
             dbgPrint "create_relay_allocator_join: #{@name}, #{name}\n"
-            # å¼ã³å£å´ã®çµåãåãåºã
+            # 呼び口側の結合を取り出す
             ja = @join_list.get_item( :"#{ai2[3]}_#{ai2[4]}_#{ai2[5]}" )
             if ja == nil then
-              # è¦ã¤ãããªãå ´å
+              # 見つからない場合
               found = false
               
-              # composite å
-ã§å¤é¨ã«çµåããã¦ããã
+              # composite 内で外部に結合されているか
               if @in_composite then
                 @compositecelltypejoin_list.get_items.each { |cj|
@@ -2597,22 +2472,19 @@
                 cdl_error( "S1041 \'$1_$2_$3\': not joined. cannot create internal join for relay allocator" , ai2[3], ai2[4], ai2[5] )
                 print( "      In cell #{get_name}\n" )
-                # join ãæªçµåã§ãããã¨ã®ã¨ã©ã¼ã¯äºåº¦ã§ã (S1043)
+                # join が未結合であることのエラーは二度でる (S1043)
               end
-              next    # æã¡åã
+              next    # 打ち切る
             end
 
             b_export = false
-            # composite å
-ã®ã»ã«ã§ã¨ã¯ã¹ãã¼ãããã¦ããããã§ãã¯
-            #  mikan ã¨ã¯ã¹ãã¼ãå´ã¨ããã¡ãå´ã§ããªã¬ã¼å
-ãä¸è´ããããã§ãã¯ãå¿
-è¦
+            # composite 内のセルでエクスポートされているかチェック
+            #  mikan エクスポート側と、こちら側で、リレー先が一致するかチェックが必要
             if @compositecelltypejoin_list then
-              # export ããã¦ãããèª¿ã¹ã
+              # export されているか調べる
               @compositecelltypejoin_list.get_items.each{ |cj|
-                # å±æ§åã¨ composite ã® export ããååã¯ä¸è´ããã
+                # 属性名と composite の export する名前は一致するか
                 if p.get_name == cj.get_cell_elem_name then
                   print "export : #{p.get_name}\n"
-                  b_export = true    # å±æ§ã¯ export ããã¦ããã®ã§ãã¨ããããæªåæåã¨ã¯ããªã
+                  b_export = true    # 属性は export されているので、とりあえず未初期化とはしない
                   break
                 end
@@ -2621,6 +2493,5 @@
             end
 
-            # mikan é
-å
+            # mikan 配列
             am = nil
             if am then
@@ -2629,12 +2500,10 @@
                 subscript = ja2.get_subscript
                 if b_export == false then
-                  # CompositeCelltype ã®å ´åãå
-å´ã®ã»ã«ã§çæããã
+                  # CompositeCelltype の場合、内側のセルで生成させる
                   join = Join.new( :"#{p.get_name}_#{ai2[1]}_#{ai2[2]}", subscript, rhs, @loacle )
                   # p ( "#{p.get_name}_#{ai2[1]}_#{ai2[2]}", subscript, rhs )
                   new_join( join )
                   join.set_definition( @celltype.find(join.get_name) )
-                  # mikan relay mismatch ãã§ãã¯ãã§ãã¦ããªãï¼ä¸æ¹ãåç
-§ï¼
+                  # mikan relay mismatch チェックができていない（下方を参照）
                 end
                 @alloc_list << [ :NORMAL_ALLOC, p.get_name, subscript, ai2[1], ai2[2], rhs ]
@@ -2642,6 +2511,5 @@
             else
               if b_export == false then
-                # CompositeCelltype ã®å ´åãå
-å´ã®ã»ã«ã§çæããã
+                # CompositeCelltype の場合、内側のセルで生成させる
                 join = Join.new( :"#{p.get_name}_#{ai2[1]}_#{ai2[2]}", nil, ja.get_rhs, @locale )
                 new_join( join )
@@ -2653,6 +2521,5 @@
                                       "#{p.get_name}_#{ai2[1]}_#{ai2[2]}",
                                       "#{ai2[3]}_#{ai2[4]}_#{ai2[5]}" )
-                    # æ¬å½ã¯ composite ã®å¼ã³å£ã¨åãå£ã®éã§è¡ãã¹ãã ããå
-é¨ã§å¤æ®µæ¥ç¶ããã¦ããå ´å
+                    # 本当は composite の呼び口と受け口の間で行うべきだが、内部で多段接続されている場合
                   else
                     dbgPrint "relay success:  #{p.get_name}_#{ai2[1]}_#{ai2[2]}=>#{ai2[3]}_#{ai2[4]}_#{ai2[5]} #{jr.get_rhs_cell2.get_name}.#{jr.get_rhs_port2} \n"
@@ -2669,7 +2536,6 @@
   end
 
-  #=== Cell# @@cell_list2 ãä½ã
-  # @@cell_list2 ã¯ãåºç¾é ã« composite å
-ãå«ãã»ã«ã®ãªã¹ã
+  #=== Cell# @@cell_list2 を作る
+  # @@cell_list2 は、出現順に composite 内を含むセルのリスト
   def self.make_cell_list2
     @@cell_list.each{ |c|
@@ -2679,19 +2545,18 @@
   end
 
-  #=== Cell# @@cell_list2 ãå¾ã
-  # composite å
-ãå«ã (compositeãå«ã)
-  # æå³è§£æå¾ã«ä½æããã
+  #=== Cell# @@cell_list2 を得る
+  # composite 内を含む (compositeも含む)
+  # 意味解析後に作成される
   def self.get_cell_list2
     @@cell_list2
   end
 
-  #=== Cell# @@cell_list ãå¾ã
-  #composite ã®ä¸­ãå«ã¾ãªã
+  #=== Cell# @@cell_list を得る
+  #composite の中を含まない
   def self.get_cell_list
     @@cell_list
   end
 
-  #=== Cell# reverse_join ãçæãã
+  #=== Cell# reverse_join を生成する
   def self.create_reverse_join
     @@cell_list.each{ |c|
@@ -2705,5 +2570,5 @@
   end
 
-  #=== Cell# reverse_require_join ãçæãã
+  #=== Cell# reverse_require_join を生成する
   def self.create_reverse_require_join
     @@cell_list2.each{ |c|
@@ -2711,5 +2576,5 @@
       # if c.is_generate? then
         if ct then
-          # self ã¸ã®å¼ã³å£å´ã®çµåãçæ
+          # self への呼び口側の結合を生成
           ct.create_reverse_require_join c
         end
@@ -2718,21 +2583,16 @@
   end
 
-  #=== Cell# åãå£ã®port ã®åç
-§ã«ã¦ã³ããè¨­å®ãã
-  # self ã¯å¼ã³å
-ã®ã»ã«
-  # å¼ã³å
-ã»ã«ã®åãå£ã®åç
-§ã«ã¦ã³ããã¢ãããã
+  #=== Cell# 受け口のport の参照カウントを設定する
+  # self は呼び元のセル
+  # 呼び先セルの受け口の参照カウントをアップする
   def set_port_reference_count
     @join_list.get_items.each { |j|
       if j.get_definition.instance_of? Port then
         am = j.get_array_member2
-        if am then             # å¼ã³å£é
-å
+        if am then             # 呼び口配列
           am.each { |j2|
-            next if j2 == nil    # optional ã§ä¸é¨ãæ¬ è½ãã¦ããã±ã¼ã¹
+            next if j2 == nil    # optional で一部が欠落しているケース
             cell = j2.get_rhs_cell2
-            next if cell == nil     # å³è¾ºãè¦ã¤ãããªãã£ãï¼æ¢ã«ã¨ã©ã¼
+            next if cell == nil     # 右辺が見つからなかった．既にエラー
             port = cell.get_celltype.find( j2.get_rhs_port2 )
             dbgPrint( "set_port_reference_count: #{@name}.#{j2.get_name} => #{cell.get_name}.#{port.get_name}\n")
@@ -2741,9 +2601,9 @@
         else
           cell = j.get_rhs_cell2
-          next if cell == nil || cell.get_celltype == nil     # å³è¾ºãè¦ã¤ãããªãã£ãï¼æ¢ã«ã¨ã©ã¼
+          next if cell == nil || cell.get_celltype == nil     # 右辺が見つからなかった．既にエラー
           port = cell.get_celltype.find( j.get_rhs_port2 )
           if port == nil then
             dbgPrint "set_port_ref: #{@name}.#{j.get_name} = #{cell.get_name}.#{j.get_rhs_port2}\n"
-            # through ãã©ã°ã¤ã³ã§çæãããã»ã«ã®åãå£ãè¦ã¤ãããªãã±ã¼ã¹ (ã®ããº)
+            # through プラグインで生成されたセルの受け口が見つからないケース (のハズ)
             cdl_error( "entry '$1' not found in '$2' refered from $3.$4", j.get_rhs_port2, cell.get_name, @name, j.get_name )
             next
@@ -2756,20 +2616,18 @@
   end
 
-  #=== Cell# çµå(Join)ã®ãã§ãã¯
-  #     Join ã¯å¼ã³å£ã®çµåã¾ãã¯ attribute ã®åæå
+  #=== Cell# 結合(Join)のチェック
+  #     Join は呼び口の結合または attribute の初期化
   #
-  #  mikan ãã®ã¡ã½ããã¯ãä»¥ä¸ã®ï¼ã¤ã®ãã§ãã¯ãããªãããåå²ããã»ããããé©åãªé·ãã®ã¡ã½ããã«ãªã
-  #  ã»ãªã¬ã¼ã¢ã­ã±ã¼ã¿ã®çæ => create_relay_allocator_join
-  #  ã»æªçµåã®å¼ã³å£ã®ãã§ãã¯
-  #  ã»ãã¤ã³ã¿åãé
-åã§åæåãããå ´åã®ãã§ãã¯
-  #  ã»æªåæåã®å±æ§ã®ãã§ãã¯
+  #  mikan このメソッドは、以下の４つのチェックからなるが、分割したほうがより適切な長さのメソッドになる
+  #  ・リレーアロケータの生成 => create_relay_allocator_join
+  #  ・未結合の呼び口のチェック
+  #  ・ポインタ型が配列で初期化される場合のチェック
+  #  ・未初期化の属性のチェック
   def check_join
 
-    # celltype ããªããã°ãã§ãã¯ããªãï¼æ¢ã«ã¨ã©ã¼ï¼
+    # celltype がなければチェックしない（既にエラー）
     return if @celltype == nil
     return if @b_defined == false
-    return if @f_cloned == true    # å
-é¨ã»ã«ã«ã¤ãã¦ã¯ãcomposite ã®å®ç¾©æã«ãã§ãã¯ããã¦ãã
+    return if @f_cloned == true    # 内部セルについては、composite の定義時にチェックされている
 
     # debug
@@ -2779,8 +2637,8 @@
     # end
 
-    # æªçµåã®å¼ã³å£ã®ãã§ãã¯
+    # 未結合の呼び口のチェック
     @celltype.get_port_list.each { |p|
 
-      # å¼ã³å£ã§ãªããã°ããã§ãã¯ããªã
+      # 呼び口でなければ、チェックしない
       next if p.get_port_type != :CALL
 
@@ -2788,18 +2646,17 @@
       dbgPrint "check_join: #{@name} #{get_celltype.get_name} #{p.get_name}\n"
 
-      # çµåãªã¹ãã®ä¸­ããå¼ã³å£åã«ä¸è´ãããã®ãåãã ã
+      # 結合リストの中から呼び口名に一致するものを取りだす
       j = @join_list.get_item( p.get_name )
 
       if j == nil then
-        # æªçµåã®å¼ã³å£
-
-        # composite celltype ã®å
-é¨ã®å ´åãcomposite celltype ã export ããå¼ã³å£ã«çµåããã¦ãããæ¢ã
+        # 未結合の呼び口
+
+        # composite celltype の内部の場合、composite celltype が export する呼び口に結合されているか探す
         found = false
         if @in_composite then
-          # composite celltype ã® export ãããã®ãã¹ã¦ããæ¢ã
-          # ï¼export ãããã®ã®å³è¾ºå¤ããæ¢ãããã« get_item ã§ã¯ãã¡ï¼
+          # composite celltype の export するものすべてから探す
+          # （export するものの右辺値から探すために get_item ではダメ）
           @compositecelltypejoin_list.get_items.each{ |cj|
-            # å¼ã³å£åã¨ composite ã® export ããååã¯ä¸è´ããã
+            # 呼び口名と composite の export する名前は一致するか
             if p.get_name == cj.get_cell_elem_name then
               found = true
@@ -2808,7 +2665,5 @@
         end
 
-        # å¼ã³å£é
-åã®å ´å optional ã§å
-¨ã¦ã®è¦ç´ ãåæåãããªãå ´åã«ãããã¸æ¥ã
+        # 呼び口配列の場合 optional で全ての要素が初期化されない場合に、ここへ来る
         if ! found && ! p.is_require? && ! p.is_optional? then
           if ! p.is_allocator_port? then
@@ -2819,28 +2674,21 @@
         end
       elsif p.get_array_size.kind_of? Integer then
-        # æ·»æ°ããå¼ã³å£é
-åã®å ´åããã¹ã¦ã®æ·»æ°è¦ç´ ãåæåããã¦ããããã§ãã¯ãã
+        # 添数あり呼び口配列の場合、すべての添数要素が初期化されているかチェックする
 
         am = j.get_array_member2
         if( am )then
-          # join ã¯é
-å
-
-          # å¼ã³å£é
-åå®ç¾©ã§ã®é
-åã®å¤§ãã
+          # join は配列
+
+          # 呼び口配列定義での配列の大きさ
           length = p.get_array_size
 
-          # é
-åã®å¤§ãããå¼ã³å£é
-åå®ç¾©ã¨çµåå®ç¾©ã§ä¸è´ãããï¼
+          # 配列の大きさが呼び口配列定義と結合定義で一致するか？
           if am.length != length then
             if ! p.is_optional? || am.length >= length then
-              # optional ã®å ´åãè¦ç´ æ°ãå°ãªãããã®ã¯ OK
+              # optional の場合、要素数が少なすぎるのは OK
               cdl_error( "S1044 $1: array initializer too many or few, $2 for $3" , p.get_name, am.length, length )
             end
 
-            # am ã®è¦ç´ ã« nil ãè¿½å ãã¦ãã (#_CPA_# ã®ã³ã¼ãçææããã®é
-åè¦ç´ æ°åçæ)
+            # am の要素に nil を追加しておく (#_CPA_# のコード生成時、この配列要素数分生成)
             i = am.length
             while i < length
@@ -2850,7 +2698,6 @@
           end
 
-#          # é
-åè¦ç´ ã®æãããªãããã§ãã¯
-#          if am.length < length then  # æºããªãå ´åæ¢ã«ã¨ã©ã¼ã ãè¦ç´ ã®ããç¯å²ã§ãã§ãã¯
+#          # 配列要素の抜けがないかチェック
+#          if am.length < length then  # 満たない場合既にエラーだが要素のある範囲でチェック
 #            length = am.length
 #          end
@@ -2862,5 +2709,5 @@
               end
             else
-              # çæãããªããªã¼ã¸ã§ã³ã¸ã®çµåããã§ãã¯
+              # 生成されないリージョンへの結合かチェック
               if ! @in_composite then
                 am[i].check_region2
@@ -2871,10 +2718,8 @@
 
         # else
-        # join ãéé
-åã§ããã°ãæ¢ã«ã¨ã©ã¼
+        # join が非配列であれば、既にエラー
         end
       elsif j.get_array_member then
-        # æ·»æ°ãªãå¼ã³å£é
-åã®å ´å
+        # 添数なし呼び口配列の場合
         am = j.get_array_member2
         length = am.length
@@ -2889,5 +2734,5 @@
         end
 
-        # çæãããªããªã¼ã¸ã§ã³ã¸ã®çµåããã§ãã¯
+        # 生成されないリージョンへの結合かチェック
         if ! @in_composite then
           am.each { |join|
@@ -2898,8 +2743,7 @@
         end
       else
-        # å¼ã³å£ï¼»é
-åãã§ãªãå ´å
-
-        # çæãããªããªã¼ã¸ã§ã³ã¸ã®çµåããã§ãã¯
+        # 呼び口［配列」でない場合
+
+        # 生成されないリージョンへの結合かチェック
         if ! @in_composite then
           j.check_region2
@@ -2909,11 +2753,10 @@
     }
 
-    # ãã¤ã³ã¿åãé
-åã§åæåãããå ´åã®ãã§ãã¯
+    # ポインタ型が配列で初期化される場合のチェック
     (@celltype.get_attribute_list+@celltype.get_var_list).each { |a|
       if a.get_size_is then
 
         if a.instance_of? CompositeCelltypeJoin then
-          # æ¢ã«ã¨ã©ã¼ã«ãªã£ã¦ãã
+          # 既にエラーになっている
           # cdl_error( "S1047 size_is pointer cannot be exposed for composite attribute"  )
           next
@@ -2925,6 +2768,6 @@
           size = a.get_size_is.eval_const( @join_list, @celltype.get_name_list )
           a.get_type.set_scs( a.get_size_is, nil, nil, nil, false )
-          if( ! size.kind_of? Integer )then               # C_EXP ã®å¯è½æ§ãã
-            # mikan å¤åããã§ã®ã¨ã©ã¼çºçã¯ä¸è¦ãeval_const ã®ä¸­ã§å¤æ°ãå­å¨ããªããåãä¸é©åãªã©ã®ã¨ã©ã¼ã«ãªãã¯ã
+          if( ! size.kind_of? Integer )then               # C_EXP の可能性あり
+            # mikan 多分ここでのエラー発生は不要、eval_const の中で変数が存在しない、型が不適切などのエラーになるはず
             cdl_error( "S1049 $1: size_is arg not constant" , a.get_name )
           else
@@ -2942,5 +2785,5 @@
               end
             else
-              # size_is å¼æ°ãã»ã«ã§æå®ããã¦ãã¦ãåæåå­ãã»ã«ã¿ã¤ãã§æå®ããã¦ããã±ã¼ã¹ã®ãã§ãã¯
+              # size_is 引数がセルで指定されていて、初期化子がセルタイプで指定されているケースのチェック
               ini = a.get_initializer
               if ini.instance_of? Expression
@@ -2957,9 +2800,9 @@
       else
         if ! a.instance_of? CompositeCelltypeJoin then
-          # composite ã¯ size_is æå®ã§ããªã
+          # composite は size_is 指定できない
           if a.get_type.kind_of?( PtrType ) then
             j = @join_list.get_item( a.get_identifier )
             if j && j.get_rhs.instance_of?( Array ) then
-              ## size_is æå®ããã¦ããªããã¤ã³ã¿ã Array ã§åæåããã¦ããããã¨ã©ã¼ã¨ãã
+              ## size_is 指定されていないポインタが Array で初期化されていたら、エラーとする
               cdl_error( "S1169 $1: non-size_is pointer cannot be initialized with array initializer" , a.get_identifier )
             end
@@ -2969,30 +2812,27 @@
     }
 
-    # æªåæåã®å±æ§ããã§ãã¯
+    # 未初期化の属性をチェック
     @celltype.get_attribute_list.each { |a|
       b_init = false
       # self.show_tree 1
-      if a.get_initializer then                               # ã»ã«ã¿ã¤ãã§åæåããã¦ãã
+      if a.get_initializer then                               # セルタイプで初期化されている
         b_init = true
-        # @in_composite ã§ export ããã¦ããå ´åã«ã¯ããã®åæå¤ã¯ä½¿ãããªã
-        # export ããã¦ãããããªãã«é¢ããããåæåããã¦ãããã¨ãä¿è¨¼ããã
-      elsif @join_list.get_item( a.get_name ) then            # ã»ã«ã§åæåããã¦ãã
+        # @in_composite で export されている場合には、この初期値は使われない
+        # export されている、いないに関わらず、初期化されていることが保証される
+      elsif @join_list.get_item( a.get_name ) then            # セルで初期化されている
         b_init = true
       elsif @in_composite && @compositecelltypejoin_list then
-        # å±æ§ã export ããã¦ãããèª¿ã¹ããexport ããã¦ããã°æªåæåã¨ã¯ããªã
-        # mikan ãªãã¢ãµã¼ã
+        # 属性が export されているか調べる。export されていれば未初期化とはしない
+        # mikan リニアサーチ
         @compositecelltypejoin_list.get_items.each{ |cj|
-          # å±æ§åã¨ composite ã® export ããååã¯ä¸è´ããã
+          # 属性名と composite の export する名前は一致するか
           if a.get_name.to_sym == cj.get_cell_elem_name.to_sym then
-            b_init = true    # å±æ§ã¯ export ããã¦ããã®ã§ãã¨ããããæªåæåã¨ã¯ããªã
+            b_init = true    # 属性は export されているので、とりあえず未初期化とはしない
           end
         }
         if b_init then
-          # size_is ã®å¼æ°ããããããããã§ãã¯ãã
-          # å
-é¨ã»ã«ã® size_is ãã¨ã¯ã¹ãã¼ããã size_is ã¨ãããããããã§ãã¯ãã
-          # å
-é¨ã»ã«ã¨ã¨ã¯ã¹ãã¼ãã§ååãå¤ãã¦ããå¯è½æ§ãããã®ã§ãå
-é¨ã»ã«ã® size_is ã®ååãå¤æããä¸ã§ãã§ãã¯ãã
+          # size_is の引数がマッチするかチェックする
+          # 内部セルの size_is をエクスポートする size_is とマッチするかチェックする
+          # 内部セルとエクスポートで名前を変えている可能性があるので、内部セルの size_is の名前を変換した上でチェックする
           if a.get_size_is then
             ### p "attr: get_size_is"
@@ -3000,6 +2840,5 @@
             if cj.get_port_decl.instance_of? Decl then
               ### p "attr: get_size_is 2"
-              # cj_size_is ã¯ãå¤é¨å
-¬éããã attr ã® size_is
+              # cj_size_is は、外部公開される attr の size_is
               cj_size_is = cj.get_port_decl.get_size_is
               if cj_size_is == nil then
@@ -3010,8 +2849,8 @@
               remain = exprs
               inner_to_export = {}
-			  ### exprs ã«å«ã¾ããè­å¥å­ãæãåºããå¯¾å¿ãã export ãããååãæ¢ã
+			  ### exprs に含まれる識別子を抜き出し、対応する export される名前を探す
               while remain != "" && remain != nil
                 ### p "remain ", remain
-                remain =~ /([^\w]*)([_A-Za-z][\w\d]*)/   # å¤æ°åæå­åãåãåºã 
+                remain =~ /([^\w]*)([_A-Za-z][\w\d]*)/   # 変数名文字列を取り出す 
 				if $2 == nil then
 						break
@@ -3020,5 +2859,5 @@
                 remain = $'
                 ### p exprs, $1, $2, $'
-                # size_is ã«å«ã¾ããå¤æ°ã¯ãcomposite ã§ export ããã¦ããã
+                # size_is に含まれる変数は、composite で export されているか
                 cj2 = nil
                 @compositecelltypejoin_list.get_items.each{ |cj2t|
@@ -3033,17 +2872,15 @@
                 if cj2.get_port_decl.instance_of? Decl then
                    decl2 = cj2.get_port_decl
-                   # å
-é¨ã®ååã¨å¤é¨ã®ååã®å¯¾å¿é¢ä¿ãè¨æ¶
+                   # 内部の名前と外部の名前の対応関係を記憶
                    inner_to_export[arg_name] = decl2.get_name
-                # else cj2 ã¯ Port (æ¢ã«ã¨ã©ã¼)
+                # else cj2 は Port (既にエラー)
                 end
               end
-              # å
-é¨ã®ååãå¤é¨ã®ååã§ç½®æ
+              # 内部の名前を外部の名前で置換
               inner_to_export.each{ |arg_name, exp_name|
                 ### p "changing #{arg_name}=>#{exp_name}"
                 # exprs.gsub!( Regexp.new("#{arg_name}[^0-9A-Za-z_]"), exp_name.to_s )
-                exprs.gsub!( Regexp.new("#{arg_name}(\\W)"), exp_name.to_s+"\\1" )  # æå­åæ«å°¾ã«ãªãã±ã¼ã¹
-                exprs.gsub!( Regexp.new("#{arg_name}\\Z"), exp_name.to_s )          # æå­åæ«å°¾ã«ããã±ã¼ã¹
+                exprs.gsub!( Regexp.new("#{arg_name}(\\W)"), exp_name.to_s+"\\1" )  # 文字列末尾にないケース
+                exprs.gsub!( Regexp.new("#{arg_name}\\Z"), exp_name.to_s )          # 文字列末尾にあるケース
               }
               ### p "changed: #{exprs} #{cj_size_is.to_s}"
@@ -3051,5 +2888,5 @@
                 cdl_error( "S1172 \'$1\' size_is argument mismatch with exporting one \'$2\'", a.get_name, cj.get_name )
               end
-            # else cj ã¯ Port (æ¢ã«ã¨ã©ã¼)
+            # else cj は Port (既にエラー)
             end
           end
@@ -3064,15 +2901,14 @@
   end
 
-  #=== Cell# é require ããã§ãã¯ãã
-  # é require æå®ãããåãå£ã«è¤æ°ã®çµåããªãããã§ãã¯ãã
-  # composite ã®å
-é¨ã»ã« (f_cloned=true) ããã§ãã¯ãã
+  #=== Cell# 逆 require をチェックする
+  # 逆 require 指定された受け口に複数の結合がないかチェックする
+  # composite の内部セル (f_cloned=true) もチェックする
   def check_reverse_require
-    # celltype ããªããã°ãã§ãã¯ããªãï¼æ¢ã«ã¨ã©ã¼ï¼
+    # celltype がなければチェックしない（既にエラー）
     return if @celltype == nil
     return if @b_defined == false
 
     # p "check reverse require   #{@name}"
-    # érequire æå®ãããåãå£ã«è¤æ°ã®çµåããªãããã§ãã¯
+    # 逆require 指定された受け口に複数の結合がないかチェック
     @referenced_port_list.each{ |port,count|
       # p port.class, count
@@ -3084,13 +2920,13 @@
   end
 
-  #=== Cell# require å¼ã³å£ã®çµåãè¡ã
+  #=== Cell# require 呼び口の結合を行う
   # STAGE: S
-  #cp_name:: Symbol           : å¼ã³å£å
-  #cell_or_t:: Celltype|Cell  : celltype ã® require ã®å³è¾ºã§æå®ãããã»ã«ã¿ã¤ãã¾ãã¯ã»ã«
-  #port::  Port               : celltype ã® Port ãªãã¸ã§ã¯ã
+  #cp_name:: Symbol           : 呼び口名
+  #cell_or_t:: Celltype|Cell  : celltype の require の右辺で指定されたセルタイプまたはセル
+  #port::  Port               : celltype の Port オブジェクト
   def set_require_join( cp_name, cell_or_ct, port )
 
-    # set_require_join ã¯2åº¦å¼ã³åºããã
-    # 2åº¦ç®ã¯ post ã³ã¼ããçæããå¾       #####  ãã£ããè¦åããï¼éè¤ã¨ã©ã¼ãè¦éãï¼
+    # set_require_join は2度呼び出される
+    # 2度目は post コードを生成した後       #####  いったん見合わせ（重複エラーを見逃す）
     # if @require_joined_list[ cp_name ] then
     #   return
@@ -3109,5 +2945,5 @@
       end
     else
-      # require: cell ã§æå®
+      # require: cell で指定
       cell = cell_or_ct
       if @region.distance( cell.get_region ) == nil then
@@ -3119,5 +2955,5 @@
       cdl_warning( "W1003 $1 : require call port overridden in $2" , cp_name, @name )
     else
-      # require ã® join ãçæ(å¼ã³å£ã®çµå)
+      # require の join を生成(呼び口の結合)
 #      rhs = Expression.new( [ :OP_DOT, [ :IDENTIFIER, Token.new( cell.get_name, nil, nil, nil ) ],
       nsp = NamespacePath.new( cell.get_name, false, cell.get_namespace )
@@ -3132,16 +2968,14 @@
   end
 
-  #=== Cell# Join ã® definition ã®è¨­å®ã¨ãã§ãã¯
+  #=== Cell# Join の definition の設定とチェック
   # STAGE: S
   def set_definition_join
-    return if @celltype == nil    # æ¢ã«ã¨ã©ã¼ï¼æã¡åã
-    return if @b_defined == false # ãã­ãã¿ã¤ãå®£è¨ã®ã¿
-    return if @b_checked == true  # æ¢ã«è¨­å®ï¼ãã§ãã¯ï¼æ¸ã¿
+    return if @celltype == nil    # 既にエラー：打ち切る
+    return if @b_defined == false # プロトタイプ宣言のみ
+    return if @b_checked == true  # 既に設定（チェック）済み
 
     dbgPrint "set_definition_join in #{@name}\n"
 
-    # relay allocator ããã©ã£ã¦åå
-¥ããªããããå
-é ­ã§ @b_checked ã true ã«ãã
+    # relay allocator をたどって再入しないよう、先頭で @b_checked を true にする
     @b_checked = true
 
@@ -3149,10 +2983,7 @@
       check_restrict_list
       
-      # compoiste ã»ã«ã®ã¯ã­ã¼ã³ããããã®ã¯ãset_definition ä¸è¦
-      # å
-ã® join ã¯æ¢ã« definition ããã¦ãã
-      # å
-ã®ã»ã«ã«ããã¦ãä»£å
-¥ãã§ãã¯ããã¦ããã®ã§ãäºéã«ãã§ãã¯(throughé©ç¨)ããã¦ãã¾ã
+      # compoiste セルのクローンされたものは、set_definition 不要
+      # 元の join は既に definition されている
+      # 元のセルにおいて、代入チェックされているので、二重にチェック(through適用)されてしまう
       @join_list.get_items.each{ |join|
         dbgPrint " set_definition_join: checking #{@name}.#{join.get_name}\n"
@@ -3160,7 +2991,7 @@
           port = @celltype.find(join.get_name)
           join.get_array_member2.each { |am|
-            if am == nil then   # æªçµåã®å ´åãã¨ã©ã¼ãã§ãã¯ã¯ check_join
+            if am == nil then   # 未結合の場合、エラーチェックは check_join
               if port && ! port.is_optional? then
-                # ãã¹ãç¨ã«ã¨ã©ã¼ã¡ãã»ã¼ã¸åºå
+                # テスト用にエラーメッセージ出力
                 # cdl_error( "TEMPORAL set_definition_join: uninitialized array member"  )
               end
@@ -3176,22 +3007,18 @@
     end
 
-    # ãªã¬ã¼ join ã¯ through ãã©ã°ã¤ã³çæå¾ã«ããã§ããªã
-    # through å¾ã«çµåå
-ãå
-¥ãæ¿ãããã 
+    # リレー join は through プラグイン生成後にしかできない
+    # through 後に結合先が入れ替えられる 
     create_relay_allocator_join
 
-    # composite ã»ã«ã®å±é
+    # composite セルの展開
     if ! @in_composite && ! @f_cloned && @celltype.instance_of?( CompositeCelltype ) then
-      # composite ã»ã«ã¿ã¤ãå
-ã® composite ã¯å±éããªã
-      # compoiste ã»ã«å±éä¸­ã® composite ã¯å±éããªã (CompositeCelltype::expand å
-ã§åå¸°çã« expnad)
+      # composite セルタイプ内の composite は展開しない
+      # compoiste セル展開中の composite は展開しない (CompositeCelltype::expand 内で再帰的に expnad)
       expand
     end
   end
 
-  #=== Cell# composite ã»ã«ã®å±é
-  # ãã®ã»ã«ã composite ã»ã«ã¿ã¤ã
+  #=== Cell# composite セルの展開
+  # このセルが composite セルタイプ
   def expand
 
@@ -3199,10 +3026,8 @@
     dbgPrint "=====    expanding   #{@name}     =====\n"
 
-    # composite celltype ã® cell ãå±é
+    # composite celltype の cell を展開
     @cell_list, @cell_list2 = @celltype.expand( @name, @global_name, @NamespacePath, @join_list, @region, @plugin, @locale )
 
-    # ãã­ãã¿ã¤ããåç
-§ããã¦ããå ´åãå­ãåç
-§ããã¦ãããã¨ã«ãã
+    # プロトタイプが参照されている場合、子も参照されていることにする
     if @f_ref then
       dbgPrint "expand: set_f_ref\n"
@@ -3211,6 +3036,5 @@
   end
 
-  #=== Cell#å
-é¨ã»ã«ã®åãå£æ·»æ°æå¤§å¤ãè¨­å®
+  #=== Cell#内部セルの受け口添数最大値を設定
   def set_max_entry_port_inner_cell
     if @cell_list == nil then
@@ -3220,5 +3044,5 @@
     dbgPrint "set_max_entry_port_inner_cell name=#{@name} entry_array_max_subscript.len=#{@entry_array_max_subscript.length}\n"
 
-    # ãã­ãã¿ã¤ãå®£è¨ã§è¨­å®ããã¦ãããã®ãåæ ãã
+    # プロトタイプ宣言で設定されていたものを反映する
     @entry_array_max_subscript.each{ |port,name|
       dbgPrint "set_entry_inner_port_max_subscript( #{port}, #{name} )\n"
@@ -3227,5 +3051,5 @@
   end
 
-  #=== Cell#restrict ãè¿½å 
+  #=== Cell#restrict を追加
   def add_restrict( entry_name, func_name, region_name_list )
     if @restrict_list[ entry_name ] == nil then
@@ -3260,8 +3084,7 @@
             else
               cdl_info( "I9999 $1: restrict calling domain to $2, which is same domain as the cell locates", @name, rp.to_s )
-              # restrict ãåããã¡ã¤ã³ãæå®ãã¦ããããã¨ã¨ãã (HRP3)
-              # KernelDoamin å
-ã®ã»ã«ã«å¯¾ããKernelDomain ã« restrict ãã¦ããå ´åã
-              # ç¡æå±çµç±ã§çµåããã¦ããããKernelDomain ããå¼åºããã¨ãæ³å®ããè¨±å¯
+              # restrict を同じドメインを指定してもよいこととする (HRP3)
+              # KernelDoamin 内のセルに対し、KernelDomain に restrict している場合、
+              # 無所属経由で結合されているが、KernelDomain から呼出すことを想定した許可
             end
           else
@@ -3311,6 +3134,6 @@
 
   #=== Cell#get_callable_regions( entry_name, func_name )
-  # func_name=nil ã®å ´åãentry_name ã®å¯å¦ããã§ãã¯æ°ã
-  # nil ãè¿ãå ´åãå¶éããã¦ããªããã¨ãæå³ãã
+  # func_name=nil の場合、entry_name の可否をチェック数る
+  # nil が返る場合、制限されていないことを意味する
   def get_restricted_regions( entry_name, func_name )
     # p "get_restricted_regions #{@name}"
@@ -3327,8 +3150,6 @@
 
   #=== Cell#has_ineffective_restrict_specifier
-  # restrict æå®å­ãæå®ããã¦ãã¦ãåç
-§ããã¦ããªãå ´å true
-  # åç
-§ã¯ãHRPSVCPlugin ã®ã¿
+  # restrict 指定子が指定されていて、参照されていない場合 true
+  # 参照は、HRPSVCPlugin のみ
   def has_ineffective_restrict_specifier
     if @restrict_list.length != 0 && @b_restrict_referenced == false then
@@ -3358,5 +3179,5 @@
       puts "entry array #{port.get_name}: max subscript=#{num}"
     }
-    if @cell_list then   # ããã§ @cell_list ã nil ãªã®ã¯ Bug
+    if @cell_list then   # ここで @cell_list が nil なのは Bug
       (indent+1).times { print "  " }
       puts "cloned cell list:"
@@ -3382,5 +3203,5 @@
           subscript = ""
         end
-        # ã¢ã­ã±ã¼ã¿å¼ã³å£ã®çµåãçæ
+        # アロケータ呼び口の結合を生成
         (indent+2).times { print "  " }
         puts "#{cp_name}#{subscript} = #{a[4+1]}"
@@ -3407,8 +3228,8 @@
 # @real_singleton:: bool : has singleton cell in this composite celltype
 # @real_active:: bool : has active cell in this composite celltype
-# @name_list:: NamedList item: Decl (attribute), Port ã¨ã¯ã¹ãã¼ãå®ç¾©
+# @name_list:: NamedList item: Decl (attribute), Port エクスポート定義
 # @internal_allocator_list:: [ [cell, internal_cp_name, port_name, func_name, param_name, ext_alloc_ent], ... ]
-# @generate:: [ Symbol, String, Plugin ]  = [ PluginName, option, Plugin ] Plugin ã¯çæå¾ã«è¿½å ããã
-# @generate_list:: [ [ Symbol, String, Plugin ], ... ]   generate æã§è¿½å ããã generate
+# @generate:: [ Symbol, String, Plugin ]  = [ PluginName, option, Plugin ] Plugin は生成後に追加される
+# @generate_list:: [ [ Symbol, String, Plugin ], ... ]   generate 文で追加された generate
 
   @@nest_stack_index = -1
@@ -3453,5 +3274,5 @@
 
     Namespace.new_compositecelltype( self )
-    set_namespace_path # @NamespacePath ã®è¨­å®
+    set_namespace_path # @NamespacePath の設定
 
     @port_list = []
@@ -3469,5 +3290,5 @@
   # CompositeCelltype#end_of_parse
   def end_of_parse
-    # singleton ã«é¢ãããã§ãã¯
+    # singleton に関するチェック
     if @b_singleton && @real_singleton == nil then
       cdl_warning( "W1004 $1 : specified singleton but has no singleton in this celltype" , @name )
@@ -3478,5 +3299,5 @@
     end
 
-    # active ã«é¢ãããã§ãã¯
+    # active に関するチェック
     if @b_active && @real_active == nil then
       cdl_error( "S1054 $1 : specified active but has no active in this celltype" , @name )
